class rngtest
{
	/* array with numberofbitssetto1 */
	char RNGTEST_bit1cnt[256];

	/* ringbuffer of 20000 bits */
	unsigned char RNGTEST_rval[20000/8];
	/* point to current, ehr, thing */
	int RNGTEST_p;
	/* number of bits in ringbuffer */
	int RNGTEST_nbits;
	/* number of new bits after a long-test */
	int RNGTEST_nnewbits;

	/* number of bits set to 1 (monobit test) */
	int RNGTEST_n1;

	/* for poker test */
	int RNGTEST_pokerbuf[16];

	/* where to store statistics */
	struct
	{
		int monobit;
		int poker;
		int longrun;
		int runs;
	} stats;
	char rngtest_stats[4096];

	char *user;

public:
	rngtest(char *puser);
	void RNGTEST_add(unsigned char newval);
	char RNGTEST_shorttest(void);
	char RNGTEST_longtest(void);
	char RNGTEST(void);
	char *RNGTEST_stats(void);
};
